<template>
  <div>
    <h5>Разворачиваем новую БД на основе cуществующей</h5>
    <br />

    <div class="grid">
      <div class="grid-itm1">SignalR UserID</div>

      <div class="grid-itm2">
        <dx-text-box :value="signaRuserID" :read-only="true" />
      </div>

      <div class="grid-itm3"></div>

      <div class="grid-itm4">Родительская БД</div>

      <div class="grid-itm5">
        <dx-text-box
          v-model="dbParentName"
          value-change-event="keyup"
          placeholder="DWH-DEV"
          :read-only="true"
        />
      </div>

      <div class="grid-itm6"></div>

      <div class="grid-itm7">Имя новой БД</div>

      <div class="grid-itm8">
        <dx-text-box v-model="dbNewName" value-change-event="keyup" />
      </div>
      <div class="grid-itm9"></div>

      <div class="grid-itm10">Имя бакапа</div>
      <div class="grid-itm11">
        <dx-text-box v-model="dbBackupName" />
      </div>

      <div class="grid-itm12">
        <dx-button
          id="btnStart"
          type="default"
          text="Старт"
          :disabled="IsDisabledBtnStart"
          @click="onBtnRestore"
          width="80px"
        />
      </div>

      <div class="grid-progress-bar">
        <dx-progress-bar
          id="progress-bar-status"
          :class="{complete: seconds == 0}"
          :min="0"
          :max="maxValue"
          :value="progressValue"
          :showStatus="false"
        />
      </div>

      <div class="grid-lbl-progress">{{typeOperationSql}}: {{progressValue}}%</div>

      <div class="grid-mdgsql-full" v-if="messageSqlFull.length > 0">
        <div>
          <span style="color: black">Сообщение sql-сервера:</span>
          {{messageSqlFull}}
        </div>
      </div>

      <div class="grid-mdgsql-error" v-if="messageSqlError.length > 0">
        <div>
          <span style="color: black">Сообщение sql-сервера:</span>
          {{messageSqlError}}
        </div>
      </div>

      <div class="grid-mdgsql-success" v-if="messageSqlSuccess.length > 0">
        <div>
          <span style="color: black">Сообщение sql-сервера:</span>
          {{messageSqlSuccess}}
        </div>
      </div>

      <div class="grid-itm17"></div>
      <div class="grid-itm18"></div>
      <div class="grid-itm19"></div>
      <div class="grid-itm20"></div>
      <div class="grid-itm21"></div>
      <div class="grid-itm22"></div>
      <div class="grid-itm23"></div>
      <div class="grid-itm24"></div>
      <div class="grid-itm25"></div>
      <div class="grid-itm26"></div>
    </div>

    <label>Список БД на sql сервере</label>

    <br />
    <!-- блок кнопок -->
    <div style="height: 10%">
      <dx-button icon type="default" text="Обновить" @click="onGetDataSourceGrid" />
      <dx-button icon type="default" text="Очистить" @click="onClearDataSource" />
    </div>

    <br />

    <div :style="{height: windowHeight + 'px'}">
      <dx-data-grid
        id="gridContainer"
        key-expr="name"
        :data-source="dataSource"
        :repaint-changes-only="true"
        :highlight-changes="true"
        :show-borders="true"
        :focused-row-enabled="true"
        :allow-column-reordering="true"
        :row-alternation-enabled="false"
        :showRowHeaders="true"
        :allowColumnResizing="true"
        :showRowLines="true"
        :showColumnLines="true"
        style="height:100%"
        @cell-prepared="onCellRrepared"
        @focused-row-changed="onFocusedRowChanged"
      >
        <dx-column :width="115" data-field="database_id" />
        <dx-column :width="270" data-field="name" caption="База данных" />
        <dx-column :width="215" data-field="state" caption="Состояние" />
        <dx-pager
          :show-page-size-selector="true"
          :allowed-page-sizes="[5, 10, 15, 30]"
          :show-info="true"
        />
        <dx-paging :page-size="30" />
      </dx-data-grid>
    </div>
  </div>
</template>



<script>
import "devextreme/dist/css/dx.common.css";
import "devextreme/dist/css/dx.light.compact.css";
//import 'devextreme/dist/css/dx.softblue.compact.css';

import { DxTextBox, DxButton } from "devextreme-vue";
import {
  DxDataGrid,
  DxColumn,
  DxExport,
  DxEditing,
  DxGrouping,
  DxPager,
  DxPaging,
  DxColumnChooser,
  DxFilterRow,
  DxHeaderFilter,
  DxSearchPanel
} from "devextreme-vue/data-grid";
import notify from "devextreme/ui/notify";
import CustomStore from "devextreme/data/custom_store";
import { DxProgressBar } from "devextreme-vue/progress-bar";

import { HubConnectionBuilder } from "@aspnet/signalr";


const windowHeightDefault = 500;
var heightGridDB = 200;
var typeOperationSql = "";
const maxValue = 100;

// подключаем signalR
var hubConn = new HubConnectionBuilder().withUrl("/signalR_devRestore").build();
const user = require("uuid/v4");

/* async function ReconnectSignaR() {
  try {
    await hubConn.start();
    console.log("connected sussces");
  } catch (err) {
    console.log(err);
    setTimeout(() => start(), 5000);
  }
} */

export default {
  components: {
    DxTextBox,
    DxDataGrid,
    DxColumn,
    DxPager,
    DxPaging,
    DxButton,
    DxProgressBar
  },

  data() {
    return {
      connectionStarted: false,
      dataSource: null,
      signaRuserID: "",
      windowHeight: window.innerHeight - windowHeightDefault,
      dbNewName: "",
      dbParentName: "DWH-DEV",
      dbBackupName: "backup",
      progressValue: 0,
      maxValue,
      seconds: maxValue,
      inProgress: false,
      lblConn: "",
      typeOperationSql,
      messageSqlFull: "",
      messageSqlError: "",
      messageSqlSuccess: "",

      inProgressRestore: false
    };
  },

  mounted() {
    // получим датасорц для грида
    this.getDataSourceGrid();
    this.connectionStarted = true;

    //создаем событие на изменения размера страницы
    this.$nextTick(() => {
      window.addEventListener("resize", () => {
        var height = window.innerHeight - windowHeightDefault;
        if (height < heightGridDB) height = heightGridDB;
        this.windowHeight = height;
      });
    });

    //console.log(this.windowHeight);

    // устанавливаем события SignalR

    // событие сообщения sql сервера в процентах выполнения Backup
    hubConn.start().then(() => {
      hubConn.on("onPercentBackup", data => {
        this.typeOperationSql = "Процесс Backup";
        this.progressValue = data;
      });

      // событие сообщения sql сервера в процентах выполнения Restore
      hubConn.on("onPercentRestore", data => {
        this.typeOperationSql = "Процесс Restore";
        this.progressValue = data;
      });

      // событие сообщения sql сервера успешного выполнения Backup
      hubConn.on("onCompleteBackup", data => {
        this.messageSqlSuccess = data;
        this.messageSqlFull = "";
        this.messageSqlError = "";
        notify(
          {
            message: data,
            width: 800,
            shading: false
          },
          "success",
          4500
        );
      });

      // событие сообщения sql сервера успешного выполнения Restore
      hubConn.on("onCompleteRestore", data => {
        // окончание Restore
        this.messageSqlSuccess = data;
        this.messageSqlFull = "";
        this.messageSqlError = "";
        this.typeOperationSql = "";
        this.inProgressRestore = false;

        notify(
          {
            message: data,
            width: 800,
            shading: false
          },
          "success",
          4500
        );
      });

      // событие полный ответ sql сервера
      hubConn.on("onMessage", data => {
        this.messageSqlFull = data;
        this.messageSqlSuccess = "";
        this.messageSqlError = "";
      });

      hubConn.on("onError", data => {
        this.messageSqlError = data;
        this.messageSqlFull = "";
        this.messageSqlSuccess = "";
        this.inProgressRestore = false;
      });

      hubConn.on("onUserID", data => {
        this.signaRuserID = data;
      });

      // событие разрыва соединения SignalR
      hubConn.onclose(async () => {
        await this.ReconnectSignaR();
      });
    });
  },

  computed: {
    IsDisabledBtnStart: function() {
      return this.dbNewName.length > 0 && this.inProgressRestore == false
        ? false
        : true;
    }
  },

  methods: {
    // событие грида CellRrepared
    onCellRrepared(e) {
      //console.log(e.cellElement)
      // заголовок грида. alignment header ставим по центру
      if (e.rowType === "header") {
        e.cellElement.style = "text-align: center;";
      }
    },

    onGetDataSourceGrid() {
      notify("Получаем данные", "success", 600);
      this.getDataSourceGrid();
    },

    onClearDataSource() {
      notify("Удаляем данные", "warning", 600);
      this.dataSource = null;
    },

    getDataSourceGrid() {
      //обращаемся к бэку
      var http = new XMLHttpRequest();
      http.open("GET", "/api/DevRestore", false); // false for synchronous request
      http.send(null);
      this.dataSource = JSON.parse(http.responseText);
    },

    // событие кнопки Старт
    onBtnRestore() {
      this.typeOperationSql = "";
      this.progressValue = 0;
      this.messageSqlFull = "";
      this.messageSqlError = "";
      this.messageSqlSuccess = "";
      this.inProgressRestore = true;

      this.lblConn = hubConn.connectionState;

      // вызываем метод signalR на сервере
      this.sleep(100);
   

      hubConn.invoke(
        "RestoreDB",
        user(),
        this.dbParentName,
        this.dbNewName,
        this.dbBackupName
      );
    },


    ReconnectSignaR :async function () {
      try {
        await hubConn.start();
        console.log("connected sussces");

        this.typeOperationSql = "";
        this.progressValue = 0;
        this.messageSqlFull = "";
        this.messageSqlError = "";
        this.messageSqlSuccess = "";
        this.inProgressRestore = false;
        
      } catch (err) {
        console.log(err);
        setTimeout(() => start(), 5000);
      }
    },


    onFocusedRowChanged: function(e) {
      var data = e.row.data;
      this.dbParentName = data.name;
    },

    sleep: function (milliseconds) {
      var start = new Date().getTime();
      for (var i = 0; i < 1e7; i++) {
        if ((new Date().getTime() - start) > milliseconds){
          break;
        }
      }
    }  
    
    }
};
</script>


<style>
:root {
  --main-color: rgb(255, 255, 255);
  --main-fontsize: 13px;
}

.dx-row:last-child td {
  color: #000000;
  background-color: #d2d3e4;
}

/* установим в кнопках нижний регистр */
.dx-button-text {
  text-transform: lowercase;
  font-size: var(--main-fontsize);
}

/* установим в кнопках первый символ в верхнем регистре */
.dx-button-text:first-letter {
  text-transform: uppercase;
  font-size: var(--main-fontsize);
}

.dx-datagrid {
  font-size: var(--main-fontsize);
}

.dx-datagrid-headers {
  font-size: var(--main-fontsize);
}

.dx-texteditor-input {
  font-size: var(--main-fontsize);
}

#grid .dx-progressbar-container {
  height: 50px !important;
}

.grid {
  display: grid;
  grid-template-columns: 120px 1fr 420px;
  grid-template-rows: repeat(7, 30px);
  grid-column-gap: 5px;

  background: rgb(253, 253, 253);
  color: rgb(0, 0, 0);
  border: 1px solid var(--main-color);
  font-size: var(--main-fontsize);
  width: 800px;
}

.grid-itm1 {
  align-self: center;
  justify-self: left;
  border: 1px solid var(--main-color);
  font-size: var(--main-fontsize);
}

.grid-itm2 {
  align-self: center;
  justify-self: left;
  border: 1px solid var(--main-color);
  width: 100%;
  font-size: var(--main-fontsize);
}

.grid-itm3 {
  align-self: center;
  justify-self: left;
  border: 1px solid var(--main-color);
  font-size: var(--main-fontsize);
}

.grid-itm4 {
  align-self: center;
  justify-self: left;
  border: 1px solid var(--main-color);
  font-size: var(--main-fontsize);
}

.grid-itm5 {
  align-self: center;
  justify-self: left;
  border: 1px solid var(--main-color);
  width: 100%;
  font-size: var(--main-fontsize);
}

.grid-itm6 {
  align-self: center;
  justify-self: left;
  border: 1px solid var(--main-color);
  font-size: var(--main-fontsize);
}

.grid-itm7 {
  align-self: center;
  justify-self: left;
  border: 1px solid var(--main-color);
  width: 100%;
  font-size: var(--main-fontsize);
}

.grid-itm8 {
  align-self: center;
  justify-self: left;
  border: 1px solid var(--main-color);
  width: 100%;
  font-size: var(--main-fontsize);
}

.grid-itm9 {
  align-self: center;
  justify-self: left;
  border: 1px solid var(--main-color);
  font-size: var(--main-fontsize);
}

.grid-itm10 {
  align-self: center;
  justify-self: left;
  border: 1px solid var(--main-color);
  font-size: var(--main-fontsize);
  width: 100%;
  font-size: var(--main-fontsize);
}

.grid-itm11 {
  align-self: center;
  justify-self: left;
  border: 1px solid var(--main-color);
  width: 100%;
  font-size: var(--main-fontsize);
}

.grid-itm12 {
  align-self: center;
  border: 1px solid var(--main-color);
}

.grid-progress-bar {
  align-self: center;
  justify-self: left;

  border: 1px solid var(--main-color);
  grid-column: 1 / 4;
  grid-row: 5/5;
  width: 600px;
  font-size: var(--main-fontsize);
  margin-top: 10px;
}

.grid-lbl-progress {
  align-self: auto;
  justify-self: left;
  text-align: center;
  border: 1px solid(--main-color);
  grid-column: 1 / 4;
  grid-row: 6 / 6;
  color: rgb(11, 5, 95);
  font-size: var(--main-fontsize);
  width: 600px;
  margin-top: -5px;
}

.grid-mdgsql-full {
  align-self: auto;
  justify-self: left;
  border: 1px solid var(--main-color);
  grid-column: 1 / 4;
  grid-row: 7/8;
  color: black;
  font-size: 12px;
  width: 100%;
  margin-top: -10px;
}

.grid-mdgsql-error {
  align-self: auto;
  justify-self: left;
  border: 1px solid var(--main-color);
  grid-column: 1 / 4;
  grid-row: 7/8;
  color: red;
  font-size: 13px;
  font-weight: 500;
  width: 100%;
  margin-top: -10px;
}

.grid-mdgsql-success {
  align-self: auto;
  justify-self: left;
  border: 1px solid var(--main-color);
  grid-column: 1 / 4;
  grid-row: 7/8;
  color: green;
  font-size: 13px;
  font-weight: 500;
  width: 100%;
  margin-top: -10px;
}
</style>